//
//  enemy_ai.h
//  3ds_metroid
//
//  Created by jbr373 on 04/03/16.
//

#ifndef enemy_ai_h
#define enemy_ai_h

#include <3ds.h>

#include "player.h"
#include "projectile.h"
#include "actor_facing.h"
#include "stage_collision.h"

enum EnemyAIList
{
    AI_HORNOAD = 1,
    AI_YUMBO = 2,
    AI_TSUMURI = 3,
    AI_ALPHAMETROID = 4,
};

class EnemyAI
{
public:
    EnemyAI() {}
    virtual ~EnemyAI() {}
    
    virtual void enemy_ai_update(Player* pPlayer, Projectile* pProjectile, s32 &enemy_x, s32 &enemy_y, s16 &enemy_health, u8 &enemy_speed, u8 &enemy_facing, u8 &enemy_collision, u8 &enemy_anim) {}
    
    // Getters
    bool enemy_ai_get_paused() { return enemy_ai_paused; };
    bool enemy_ai_get_movement() { return enemy_ai_movement; };
    
    // Setters
    void enemy_ai_set_paused(bool value) { enemy_ai_paused = value; };
    void enemy_ai_set_movement(bool value) { enemy_ai_movement = value; };
    
private:
    bool enemy_ai_paused;
    bool enemy_ai_movement;
};

EnemyAI* enemy_ai_load(u8 enemy_ai_id);

#endif /* enemy_ai_h */
