//
//  enemy_ai_hornoads.cpp
//  3ds_metroid
//
//  Created by jbr373 on 04/03/16.
//

#include <stdio.h>

#include "enemy_ai.h"

#define MAX_HORNOADS_X_MOVEMENT                    120
#define MAX_HORNOADS_JUMP_COUNTER                  15

/*************************************************************************************************************************/
/*                                                    AI Script                                                          */
/*************************************************************************************************************************/

struct enemy_ai_hornoads : EnemyAI
{
    /****************************/
    /*          Values          */
    /****************************/
    
    u8 enemy_ai_hornoads_y_jump_counter;
    
    s32 enemy_ai_hornoads_spawn_x;
    u8 enemy_ai_hornoads_jumps;
    
    bool enemy_ai_hornoads_jumped;
    bool enemy_ai_hornoads_movement_changed;
    
    /****************************/
    /*        Constructor       */
    /****************************/
    
    enemy_ai_hornoads() : EnemyAI()
    {
        // Set Standard Variables
        enemy_ai_set_paused(false);
        enemy_ai_set_movement(true);
        
        // Set Own Variables
        enemy_ai_hornoads_y_jump_counter = 0;
        enemy_ai_hornoads_jumps = 0;
        
        enemy_ai_hornoads_jumped = false;
        enemy_ai_hornoads_movement_changed = true;
    }
    
    /****************************/
    /*         Functions        */
    /****************************/
    
    // Jumping
    void enemy_ai_hornoads_jump(s32 &enemy_y, u8 enemy_speed)
    {
        // Hornoads Jump
        if (enemy_ai_hornoads_y_jump_counter < MAX_HORNOADS_JUMP_COUNTER && enemy_ai_hornoads_jumped == false)
        {
            // Set Coordinates
            enemy_y += enemy_speed * 3;
            
            // Increase Jump Counter
            ++enemy_ai_hornoads_y_jump_counter;
            
            // Lock Jump
            if (enemy_ai_hornoads_y_jump_counter >= MAX_HORNOADS_JUMP_COUNTER)
            {
                enemy_ai_hornoads_y_jump_counter *= 2;
                enemy_ai_hornoads_jumped = true;
            }
        }
        else if (enemy_ai_hornoads_y_jump_counter > 0 && enemy_ai_hornoads_jumped == true)
        {
            // Reduce Jump Counter
            --enemy_ai_hornoads_y_jump_counter;
            
            //enemy_y -= enemy_speed;
            
            // Unlock Jump
            if (enemy_ai_hornoads_y_jump_counter == 0)
            {
                ++enemy_ai_hornoads_jumps;
                
                enemy_ai_hornoads_jumped = false;
            }
        }
    }
    
    // Main
    void enemy_ai_update(Player* pPlayer, Projectile* pProjectile, s32 &enemy_x, s32 &enemy_y, s16 &enemy_health, u8 &enemy_speed, u8 &enemy_facing, u8 &enemy_collision, u8 &enemy_anim) override
    {
        // Check if the AI is set to paused
        if (enemy_ai_get_paused() == true)
            return;
        
        // Pause AI on Death
        if (enemy_health <= 0)
        {
            enemy_ai_set_paused(true);
        }
        
        // Hornoads Jump
        enemy_ai_hornoads_jump(enemy_y, enemy_speed);

        // Change Movement Direction
        if (enemy_ai_hornoads_jumps == 2 && enemy_ai_hornoads_movement_changed == true)
        {
            // Force Facing
            enemy_facing = FACING_RIGHT;
            
            // Set Movement Change
            enemy_ai_hornoads_movement_changed = false;
            
            enemy_ai_hornoads_jumps = 0;
        }
        else if (enemy_ai_hornoads_jumps == 2 && enemy_ai_hornoads_movement_changed == false)
        {
            // Force Facing
            enemy_facing = FACING_LEFT;
            
            // Set Movement Change
            enemy_ai_hornoads_movement_changed = true;
            
            enemy_ai_hornoads_jumps = 0;
        }
    }
};

/*************************************************************************************************************************/
/*                                                     Register AI                                                       */
/*************************************************************************************************************************/

EnemyAI* load_enemy_ai_hornoads()
{
    // AI Result
    EnemyAI* pEnemyAI = NULL;
    
    // Allocate Yumbo AI Memory
    pEnemyAI = new enemy_ai_hornoads();
    
    // Return Allocation Result
    return pEnemyAI;
}