//
//  filepaths.h
//  3ds_metroid
//
//  Created by jbr373 on 15/01/16.
//

#ifndef filepaths_h
#define filepaths_h

// Line not used
#define LINE_DO_NOT_USE                 "NONE"

/* Folders */

#define FILEPATH_SOUND                  "sound/"
#define FILEPATH_IMAGE                  "images/"
#define FILEPATH_TEXT                   "text/"
#define FILEPATH_ROOM                   "rooms/"
#define FILEPATH_ITEM                   "items/"
#define FILEPATH_OBJECT                 "objects/"
#define FILEPATH_ENEMY                  "enemies/"

#define FILEPATH_BARRIERSUIT            "barriersuit/"
#define FILEPATH_POWERSUIT              "powersuit/"

/* Files */

// File Extensions
#define EXTENSIONS_MAP                  ".m2m"
#define EXTENSIONS_MINIMAP              ".m2mm"
#define EXTENSIONS_ENEMY                ".m2e"
#define EXTENSIONS_PNG                  ".png"
#define EXTENSIONS_ITEM                 ".m2i"
#define EXTENSIONS_OBJECT               ".m2o"
#define EXTENSIONS_TEXT                 ".txt"

/* Saves */

// Saves
#define FILE_SAVE                       "saves/save.m2s"

// Configuration
#define FILE_CONFIG                     "saves/config.cfg"

/* Sound */

// Background Music
#define SND_BGM_TITLE                   "sound/bgm/title.bin"
#define SND_BGM_SAMUS                   "sound/bgm/samus_appearance.bin"
#define SND_BGM_GAMEOVER                "sound/bgm/game_over.bin"

// Player Sounds
#define SND_PLR_RUN                     "sound/player/playerfx_run.bin"
#define SND_PLR_SHOOT                   "sound/player/playerfx_shoot.bin"
#define SND_PLR_CHARGE_START            "sound/player/playerfx_chargestart.bin"
#define SND_PLR_CHARGE_ONGOING          "sound/player/playerfx_chargeongoing.bin"
#define SND_PLR_CHARGE_SHOOT            "sound/player/playerfx_chargeshoot.bin"
#define SND_PLR_JUMP_SPIN               "sound/player/playerfx_jumpspin.bin"
#define SND_PLR_MORPHBALL               "sound/player/playerfx_morphball.bin"
#define SND_PLR_STANDINGMOVE            "sound/player/playerfx_standingmovement.bin"
#define SND_PLR_DAMAGE                  "sound/player/playerfx_damage.bin"
#define SND_PLR_EXPLOSION               "sound/player/playerfx_explosion.bin"
#define SND_PLR_UPGRADE_JINGLE          "sound/player/playerfx_upgrade_jingle.bin"
#define SND_PLR_RESTORE_JINGLE          "sound/player/playerfx_restore_jingle.bin"
#define SND_PLR_LEDGE_GRAD              "sound/player/playerfx_grab.bin"
#define SND_PLR_DEATH                   "sound/player/playerfx_death.bin"
#define SND_PLR_HEALTH_LOW              "sound/player/playerfx_healthlow.bin"
#define SND_PLR_WADE                    "sound/player/playerfx_wade.bin"

/* Images */

// Font
#define IMG_FONT                        "images/font.png"

// Items
#define IMG_PLAYER_ITEMS                "images/item/items.png"

// Menu
#define IMG_MENU_TITLE                  "images/menu/mm_title_top.png"
#define IMG_BTMM_TOP_BG                 "images/menu/hud_top.png"
#define IMG_BTMM_BTM_BG                 "images/menu/hud_btm.png"
#define IMG_BTMM_STATUS_BEAM            "images/menu/hud_beam_upgrades.png"
#define IMG_BTMM_STATUS_SUIT            "images/menu/hud_suit_upgrades.png"
#define IMG_BTMM_BEAMSWITCHER           "images/menu/hud_beams.png"

// HUD
#define IMG_HUD_HT_FULL                 "images/hud/ht_full.png"
#define IMG_HUD_HT_EMPTY                "images/hud/ht_empty.png"
#define IMG_HUD_BG                      "images/hud/hud_bg.png"
#define IMG_HUD_BAR                     "images/hud/hud_bar.png"
#define IMG_HUD_BAR_EMPTY               "images/hud/hud_barempty.png"

// Effects
#define IMG_EFFECTS                     "images/powersuit/fx.png"

// Projectiles
#define IMG_PROJECTILE_PLAYER           "images/projectiles/projectile_player.png"

// Player
#define IMG_PLAYER_RUNNING              "player_spritesheet_running.png"
#define IMG_PLAYER_STANDING             "player_spritesheet_standing.png"

#endif /* filepaths_h */
