//
//  game.h
//  3ds_metroid
//
//  Created by jbr373 on 28/02/16.
//

#ifndef game_h
#define game_h

#include <iostream>
#include <3ds.h>
#include <sf2d.h>
#include <sfil.h>

#include "stage.h"
#include "render.h"
#include "image.h"
#include "savefile.h"
#include "filepaths.h"
#include "menu.h"
#include "physics.h"
#include "menu_game.h"
#include "sound.h"
#include "system.h"
#include "sprite_handler.h"

enum GamePlayStates
{
    GAMEPLAYSTATE_RUNNING = 0,
    GAMEPLAYSTATE_PAUSED = 1,
    GAMEPLAYSTATE_EVENT = 2,
    GAMEPLAYSTATE_GAMEOVER = 3,
};

struct InputInfo
{
    u32 KeyDown;
    u32 KeyHeld;
    u32 KeyUp;
    touchPosition CurrentTouchPosition;
};

extern GamePlayStates gameplay(InputInfo& sInputInfo, SpriteHandler* pSpriteHandler, SaveFile* pSaveFile, Sound* pSound, Player* pPlayer, Stage* pStage, Physics* pPhysics, BottomMenu* pBottomMenu);

#endif /* game_h */
