//
//  render_item.h
//  3ds_metroid
//
//  Created by jbr373 on 15/02/16.
//

#ifndef render_item_h
#define render_item_h

#include <3ds.h>
#include <stdio.h>

#include "player.h"
#include "item.h"
#include "image.h"

#define SPRITESHEET_ITEM_WIDTH_SINGLE               40
#define SPRITESHEET_ITEM_HEIGHT_SINGLE              40
#define SPRITESHEET_ITEM_WIDTH_FULL                 240
#define SPRITESHEET_ITEM_HEIGHT_FULL                360

class RenderItem
{
public:
    RenderItem();
    virtual ~RenderItem();
    
    void renderitem_load();
    
    SpriteSheet* renderitem_get_sprite(Player* pPlayer, Item* pItem, bool animate);
    
    // Getters
    bool renderitem_get_frame_increment_happened() { return frame_increment_happened; };
    
    // Setters
    void renderitem_set_frame_increment_happened(bool value) { frame_increment_happened = value; };
    
private:
    // Frame
    u8 renderitem_frame;
    bool frame_increment_happened;
    
    // Spritesheet
    SpriteSheet* pItemSprite;
};

#endif /* render_item_h */
