//
//  render_projectile.h
//  3ds_metroid
//
//  Created by jbr373 on 01/02/16.
//

#ifndef render_projectile_h
#define render_projectile_h

#include <3ds.h>
#include <stdio.h>
#include <sf2d.h>

#include "image.h"
#include "player.h"
#include "projectile.h"

class RenderProjectile
{
public:
    RenderProjectile();
    virtual ~RenderProjectile();
    
    void renderprojectile_load();
    
    // Setters
    void renderprojectile_set_projectile_screen_pos(Player* pPlayer, Projectile* pProjectile, s32 player_camera_x, s32 player_camera_y);
    void renderprojectile_set_chargebeam_screen_pos(Player* pPlayer, s32 player_camera_x, s32 player_camera_y, u8 player_frame);
    
    void renderprojectile_reset_chargebeam_frame();
    void renderprojectile_reset_missle_smoke();
    
    // Getters
    s32 renderprojectile_get_projectile_x() { return renderprojectile_projectile_x; };
    s32 renderprojectile_get_projectile_y() { return renderprojectile_projectile_y; };
    s32 renderprojectile_get_chargebeam_x() { return renderprojectile_chargebeam_x; };
    s32 renderprojectile_get_chargebeam_y() { return renderprojectile_chargebeam_y; };
    
    SpriteSheet* renderprojectile_get_sprite(Projectile* pProjectile, bool is_right_screen);
    SpriteSheet* renderprojectile_get_chargebeam_sprite(u8 active_beam, u8 charge_beam_counter, bool increment_frame);
    SpriteSheet* renderprojectile_get_smoke_sprite(bool increment_frame);
    
private:
    void renderprojectile_update(Projectile* pProjectile);
    u8 renderprojectile_getspriteline(Projectile* pProjectile);
    
    u8 renderprojectile_chargebeam_frame;
    u8 renderprojectile_chargebeam_counter;
    
    u8 renderprojectile_missle_smoke_frame;
    u8 renderprojectile_missle_smoke_counter;
    
    s32 renderprojectile_projectile_x;
    s32 renderprojectile_projectile_y;
    s32 renderprojectile_chargebeam_x;
    s32 renderprojectile_chargebeam_y;
    
    SpriteSheet* pPlayerProjectileTex;
};

#endif /* render_projectile_h */
