//
//  savefile.hpp
//  3ds_metroid
//
//  Created by jbr373 on 15/01/16.
//

#ifndef savefile_h
#define savefile_h

#include <3ds.h>
#include <stdio.h>
#include <string>

#include "file_operations.h"
#include "files.h"

enum ActiveBeams
{
    BEAM_STANDARD = 0,
    BEAM_ICE = 1,
    BEAM_WAVE = 2,
    BEAM_SPAZER = 3,
    BEAM_PLASMA = 4
};

class SaveFile : private FileOperations
{
public:
    SaveFile();
    virtual ~SaveFile();
    
    // Default
    void savefile_load(bool is_debug);
    void savefile_new();
    void savefile_save();
    
    bool savefile_get_new_savefile() { return savefile_is_new; };
    
    // Setters
    void savefile_set_health(u8 health) { pSaveFileStruct->savefile_health = health; };
    void savefile_set_healthtanks(u8 healthtanks) { pSaveFileStruct->savefile_healthtanks = healthtanks; };
    void savefile_set_healthtanks_available(u8 healthtanks) { pSaveFileStruct->savefile_healthtanks_available = healthtanks; };
    void savefile_set_missles_total(u8 missles) { pSaveFileStruct->savefile_missles_total = missles; };
    void savefile_set_missles_available(u8 missles) { pSaveFileStruct->savefile_missles_available = missles; };
    void savefile_set_bombs(bool enable) { pSaveFileStruct->savefile_bombs = enable; };
    void savefile_set_icebeam(bool enable) { pSaveFileStruct->savefile_icebeam = enable; };
    void savefile_set_wavebeam(bool enable) { pSaveFileStruct->savefile_wavebeam = enable; };
    void savefile_set_plasmabeam(bool enable) { pSaveFileStruct->savefile_plasmabeam = enable; };
    void savefile_set_spiderball(bool enable) { pSaveFileStruct->savefile_spiderball = enable; };
    void savefile_set_highjump(bool enable) { pSaveFileStruct->savefile_highjump = enable; };
    void savefile_set_barriersuit(bool enable) { pSaveFileStruct->savefile_barriersuit = enable; };
    void savefile_set_spazerbeam(bool enable) { pSaveFileStruct->savefile_spazerbeam = enable; };
    void savefile_set_screwattack(bool enable) { pSaveFileStruct->savefile_screwattack = enable; };
    void savefile_set_springball(bool enable) { pSaveFileStruct->savefile_springball = enable; };
    void savefile_set_spacejump(bool enable) { pSaveFileStruct->savefile_spacejump = enable; };
    void savefile_set_activebeam(u8 beam) { pSaveFileStruct->savefile_activebeam = beam; };
    void savefile_set_room(u16 room) { pSaveFileStruct->savefile_room = room; };
    void savefile_set_phase(u8 phase) { pSaveFileStruct->savefile_phase = phase; };
    void savefile_set_metroids(u8 metroids) { pSaveFileStruct->savefile_metroids = metroids; };
    void savefile_set_metroids_killed(u32 metroids_killed_phase) { pSaveFileStruct->savefile_metroids_killed_phase = metroids_killed_phase; };
    void savefile_set_x(s32 x) { pSaveFileStruct->savefile_x = x; };
    void savefile_set_y(s32 y) { pSaveFileStruct->savefile_y = y; };
    void savefile_set_collected_healtanks(u32 healthtanks_flag) { pSaveFileStruct->savefile_collected_healthtanks = healthtanks_flag; };
    void savefile_set_collected_missletanks(u32 missletanks_flag) { pSaveFileStruct->savefile_collected_missletanks = missletanks_flag; };
    void savefile_set_stage_phase(u8 phase) { pSaveFileStruct->savefile_phase_stages = phase; };
    void savefile_set_minimap_flag(u32 flag);
    
    // Getters
    u8 savefile_get_health() { return pSaveFileStruct->savefile_health; };
    u8 savefile_get_healthtanks() { return pSaveFileStruct->savefile_healthtanks; };
    u8 savefile_get_healthtanks_available() { return pSaveFileStruct->savefile_healthtanks_available; };
    u8 savefile_get_missles_total() { return pSaveFileStruct->savefile_missles_total; };
    u8 savefile_get_missles_available() { return pSaveFileStruct->savefile_missles_available; };
    bool savefile_get_bombs() { return pSaveFileStruct->savefile_bombs; };
    bool savefile_get_icebeam() { return pSaveFileStruct->savefile_icebeam; };
    bool savefile_get_wavebeam() { return pSaveFileStruct->savefile_wavebeam; };
    bool savefile_get_plasmabeam() { return pSaveFileStruct->savefile_plasmabeam; };
    bool savefile_get_spiderball() { return pSaveFileStruct->savefile_spiderball; };
    bool savefile_get_highjump() { return pSaveFileStruct->savefile_highjump; };
    bool savefile_get_barriersuit() { return pSaveFileStruct->savefile_barriersuit; };
    bool savefile_get_spazerbeam() { return pSaveFileStruct->savefile_spazerbeam; };
    bool savefile_get_screwattack() { return pSaveFileStruct->savefile_screwattack; };
    bool savefile_get_springball() { return pSaveFileStruct->savefile_springball; };
    bool savefile_get_spacejump() { return pSaveFileStruct->savefile_spacejump; };
    u8 savefile_get_activebeam() { return pSaveFileStruct->savefile_activebeam; };
    u16 savefile_get_room() { return pSaveFileStruct->savefile_room; };
    u8 savefile_get_phase() { return pSaveFileStruct->savefile_phase; };
    u8 savefile_get_metroids() { return pSaveFileStruct->savefile_metroids; };
    u32 savefile_get_metroids_killed() { return pSaveFileStruct->savefile_metroids_killed_phase; };
    s32 savefile_get_x() { return pSaveFileStruct->savefile_x; };
    s32 savefile_get_y() { return pSaveFileStruct->savefile_y; };
    u32 savefile_get_collected_healtanks() { return pSaveFileStruct->savefile_collected_healthtanks; };
    u32 savefile_get_collected_missletanks() { return pSaveFileStruct->savefile_collected_missletanks; };
    u8 savefile_get_stage_phase() { return pSaveFileStruct->savefile_phase_stages; };
    u32 savefile_get_minimap_flag();
    
private:
    // Data
    SaveFileStruct* pSaveFileStruct;
    bool savefile_is_new;
};

#endif /* savefile_h */
