//
//  sprite_object.h
//  3ds_metroid
//
//  Created by jbr373 on 17/02/16.
//

#ifndef sprite_object_h
#define sprite_object_h

#include <3ds.h>
#include <stdio.h>
#include <sf2d.h>
#include <string>

#include "image.h"

class ActorSprite
{
public:
    ActorSprite();
    virtual ~ActorSprite();
    
    void actorsprite_load(std::string filepath, u8 sprite_lines, s32 sprite_w_full, s32 sprite_h_full, u8 sprite_framespeed);
    SpriteSheet* actorsprite_get_sprite(u8 sprite_line, u8 frame_min, u8 frame_max, u8 frame_current);
    void actorsprite_delete();
    
    // Getters
    std::string actorsprite_get_filepath() { return actorsprite_filepath; };
    bool actorsprite_get_frame_increment() { return actorsprite_increment_frame; };
    
    // Setters
    void actorsprite_set_frame_increment(bool value) { actorsprite_increment_frame = value; };
    void actorsprite_set_frame(u8 frame);
    
private:
    std::string actorsprite_filepath;
    
    u8 actorsprite_last_sprite_line;
    u8 actorsprite_last_min_frame;
    u8 actorsprite_last_max_frame;
    u8 actorsprite_max_sprite_line;
    
    bool actorsprite_increment_frame;
    
    SpriteSheet* pActorSprite;
};

#endif /* sprite_object_h */
