//
//  sprite_handler.hpp
//  3ds_metroid
//
//  Created by jbr373 on 17/02/16.
//

#ifndef sprite_handler_h
#define sprite_handler_h

#include <3ds.h>
#include <stdio.h>

#include "image.h"
#include "player.h"
#include "enemy.h"
#include "object.h"

#include "sprite_player.h"
#include "sprite_actor.h"

#define MAX_SPRITE_SLOTS                      9

enum ActorSpriteTypes
{
    ACTORSPRITE_TYPE_ENEMY = 0,
    ACTORSPRITE_TYPE_OBJECT = 1,
};

class SpriteHandler : public PlayerSprite
{
public:
    SpriteHandler(SaveFile* pSaveFile);
    virtual ~SpriteHandler();
    
    void spritehandler_clear_all_sprites();
    
    SpriteSheet* spritehandler_get_sprite(Player* pPlayer, bool is_in_water);
    SpriteSheet* spritehandler_get_sprite(u8 sprite_type, std::string sprite_path, u8 sprite_anim, u8 sprite_facing, u8 sprite_frame);
    SpriteSheet* spritehandler_get_effect_sprite(Player* pPlayer);
    
    void spritehandler_load_sprite(std::string sprite_path, u8 sprite_max_line, s32 sprite_w, s32 sprite_h, u8 sprite_frame_speed);
    
private:
    // Load Sprite Sheet
    void spritehandler_load_effects();
    
    // Object Sprites
    ActorSprite* pActorSprite[MAX_SPRITE_SLOTS];
    
    // Effect Spritesheet
    SpriteSheet* pTexture_Effects;
};

#endif /* sprite_handler_h */
