//
//  sprite_player.h
//  3ds_metroid
//
//  Created by jbr373 on 22/01/16.
//

#ifndef sprite_player_h
#define sprite_player_h

#include <stdio.h>
#include <3ds.h>

#include "image.h"

class PlayerSprite
{
public:
    PlayerSprite();
    virtual ~PlayerSprite();
    
    void playersprite_load_sprites(bool is_barrier_suit);
    void playersprite_clear_sprites();
    
    // Getters
    SpriteSheet* playersprite_get_sprite(u8 player_anim, u8 player_facing, u8 player_state, bool player_shooting, bool player_is_in_water);
    u8 playersprite_get_last_frame();
    u8 playersprite_get_last_anim();
    u8 playersprite_get_last_state();
    u8 playersprite_get_last_facing();
    
private:
    const char* create_load_path(bool is_barrier_suit, std::string file);
    
    u8 player_lastanim;
    u8 player_laststate;
    u8 player_lastfacing;
    
    bool player_lastshooting;
    
    SpriteSheet* player_run;
    SpriteSheet* player_standing;
    SpriteSheet* player_lastsprite;
};

#endif /* sprite_player_h */
